package com.ai.ipu.cache.redis.context;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

/**
 * @author huangbo@asiainfo.com
 * @team IPU
 * @date 2018年11月6日下午7:54:04
 * @desc 上下文数据对象设计
 * 1.不使用java对象：单点登录时，java对象的包路径需要一致。不太合理。
 * 2.不继承HashMap：继承的话，Json转换时会丢失私有属性dirty。dirty和xxxxDirty均被识别成dirty
 */
public class IpuContextData implements Serializable{
    private static final long serialVersionUID = 183972639715505942L;
    private Map<String, String> data;
    private boolean isDirty;

	public IpuContextData() {
	    data = new HashMap<String, String>();
	}
	
	public Map<String, String> getData() {
		// TODO Auto-generated method stub
		return data;
	}

	public void setData(Map<String, String> data) {
		// TODO Auto-generated method stub
		this.data = data;
		setDirty(true);
	}
	
	public void put(String key, String value){
	    data.put(key, value);
		setDirty(true);
	}
	
	public String get(String key){
		return data.get(key);
	}

	public boolean isDirty() {
		// TODO Auto-generated method stub
		return isDirty;
	}
	
	public void setDirty(boolean isDirty) {
		// TODO Auto-generated method stub
		this.isDirty = isDirty;
	}
}
